~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/Makefile.gcc-plugins

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/Makefile.gcc-plugins (Version linux-6.12-rc7) and /scripts/Makefile.gcc-plugins (Version linux-4.13.16)


  1 # SPDX-License-Identifier: GPL-2.0             !!   1 ifdef CONFIG_GCC_PLUGINS
  2                                                !!   2   __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
  3 gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) !!   3   PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
  4 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_E !!   4 
  5                 += -DLATENT_ENTROPY_PLUGIN     !!   5   SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
  6 ifdef CONFIG_GCC_PLUGIN_LATENT_ENTROPY         !!   6 
  7     DISABLE_LATENT_ENTROPY_PLUGIN += -fplugin- !!   7   gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY)        += cyc_complexity_plugin.so
                                                   >>   8 
                                                   >>   9   gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY)        += latent_entropy_plugin.so
                                                   >>  10   gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += -DLATENT_ENTROPY_PLUGIN
                                                   >>  11   ifdef CONFIG_GCC_PLUGIN_LATENT_ENTROPY
                                                   >>  12     DISABLE_LATENT_ENTROPY_PLUGIN                       += -fplugin-arg-latent_entropy_plugin-disable
                                                   >>  13   endif
                                                   >>  14 
                                                   >>  15   ifdef CONFIG_GCC_PLUGIN_SANCOV
                                                   >>  16     ifeq ($(CFLAGS_KCOV),)
                                                   >>  17       # It is needed because of the gcc-plugin.sh and gcc version checks.
                                                   >>  18       gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV)           += sancov_plugin.so
                                                   >>  19 
                                                   >>  20       ifneq ($(PLUGINCC),)
                                                   >>  21         CFLAGS_KCOV := $(SANCOV_PLUGIN)
                                                   >>  22       else
                                                   >>  23         $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
                                                   >>  24       endif
                                                   >>  25     endif
                                                   >>  26   endif
                                                   >>  27 
                                                   >>  28   gcc-plugin-$(CONFIG_GCC_PLUGIN_STRUCTLEAK)    += structleak_plugin.so
                                                   >>  29   gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_VERBOSE)     += -fplugin-arg-structleak_plugin-verbose
                                                   >>  30   gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK)     += -DSTRUCTLEAK_PLUGIN
                                                   >>  31 
                                                   >>  32   gcc-plugin-$(CONFIG_GCC_PLUGIN_RANDSTRUCT)    += randomize_layout_plugin.so
                                                   >>  33   gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT)     += -DRANDSTRUCT_PLUGIN
                                                   >>  34   gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT_PERFORMANCE) += -fplugin-arg-randomize_layout_plugin-performance-mode
                                                   >>  35 
                                                   >>  36   GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
                                                   >>  37 
                                                   >>  38   export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR
                                                   >>  39   export SANCOV_PLUGIN DISABLE_LATENT_ENTROPY_PLUGIN
                                                   >>  40 
                                                   >>  41   ifneq ($(PLUGINCC),)
                                                   >>  42     # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
                                                   >>  43     GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
                                                   >>  44   endif
                                                   >>  45 
                                                   >>  46   KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
                                                   >>  47   GCC_PLUGIN := $(gcc-plugin-y)
                                                   >>  48   GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
  8 endif                                              49 endif
  9 export DISABLE_LATENT_ENTROPY_PLUGIN           << 
 10                                                    50 
 11 gcc-plugin-$(CONFIG_GCC_PLUGIN_STRUCTLEAK)     !!  51 # If plugins aren't supported, abort the build before hard-to-read compiler
 12 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLE !!  52 # errors start getting spewed by the main build.
 13                 += -fplugin-arg-structleak_plu !!  53 PHONY += gcc-plugins-check
 14 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLE !!  54 gcc-plugins-check: FORCE
 15                 += -fplugin-arg-structleak_plu !!  55 ifdef CONFIG_GCC_PLUGINS
 16 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLE !!  56   ifeq ($(PLUGINCC),)
 17                 += -fplugin-arg-structleak_plu !!  57     ifneq ($(GCC_PLUGINS_CFLAGS),)
 18 ifdef CONFIG_GCC_PLUGIN_STRUCTLEAK             !!  58       # Various gccs between 4.5 and 5.1 have bugs on powerpc due to missing
 19     DISABLE_STRUCTLEAK_PLUGIN += -fplugin-arg- !!  59       # header files. gcc <= 4.6 doesn't work at all, gccs from 4.8 to 5.1 have
 20 endif                                          !!  60       # issues with 64-bit targets.
 21 export DISABLE_STRUCTLEAK_PLUGIN               !!  61       ifeq ($(ARCH),powerpc)
 22 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLE !!  62         ifeq ($(call cc-ifversion, -le, 0501, y), y)
 23                 += -DSTRUCTLEAK_PLUGIN         !!  63           @echo "Cannot use CONFIG_GCC_PLUGINS: plugin support on gcc <= 5.1 is buggy on powerpc, please upgrade to gcc 5.2 or newer" >&2 && exit 1
 24                                                !!  64         endif
 25 gcc-plugin-$(CONFIG_GCC_PLUGIN_STACKLEAK)      !!  65       endif
 26 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STACKLEA !!  66       ifeq ($(call cc-ifversion, -ge, 0405, y), y)
 27                 += -DSTACKLEAK_PLUGIN          !!  67         $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
 28 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STACKLEA !!  68         @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
 29                 += -fplugin-arg-stackleak_plug !!  69       else
 30 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STACKLEA !!  70         @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
 31                 += -fplugin-arg-stackleak_plug !!  71       endif
 32 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STACKLEA !!  72     endif
 33                 += -fplugin-arg-stackleak_plug !!  73   endif
 34 ifdef CONFIG_GCC_PLUGIN_STACKLEAK              << 
 35     DISABLE_STACKLEAK_PLUGIN += -fplugin-arg-s << 
 36 endif                                              74 endif
 37 export DISABLE_STACKLEAK_PLUGIN                !!  75         @:
 38                                                    76 
 39 gcc-plugin-$(CONFIG_GCC_PLUGIN_ARM_SSP_PER_TAS !!  77 # Actually do the build, if requested.
 40 ifdef CONFIG_GCC_PLUGIN_ARM_SSP_PER_TASK       !!  78 PHONY += gcc-plugins
 41     DISABLE_ARM_SSP_PER_TASK_PLUGIN += -fplugi !!  79 gcc-plugins: scripts_basic gcc-plugins-check
                                                   >>  80 ifdef CONFIG_GCC_PLUGINS
                                                   >>  81         $(Q)$(MAKE) $(build)=scripts/gcc-plugins
 42 endif                                              82 endif
 43 export DISABLE_ARM_SSP_PER_TASK_PLUGIN         !!  83         @:
 44                                                << 
 45 # All the plugin CFLAGS are collected here in  << 
 46 # filter them out of the KBUILD_CFLAGS.        << 
 47 GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fpl << 
 48 export GCC_PLUGINS_CFLAGS                      << 
 49                                                << 
 50 # Add the flags to the build!                  << 
 51 KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)         << 
 52                                                << 
 53 # Some plugins are enabled outside of this Mak << 
 54 # be included in GCC_PLUGIN so they can get bu << 
 55 gcc-plugin-external-$(CONFIG_GCC_PLUGIN_SANCOV << 
 56         += sancov_plugin.so                    << 
 57 gcc-plugin-external-$(CONFIG_GCC_PLUGIN_RANDST << 
 58         += randomize_layout_plugin.so          << 
 59                                                << 
 60 # All enabled GCC plugins are collected here f << 
 61 # scripts/gcc-scripts/Makefile.                << 
 62 GCC_PLUGIN := $(gcc-plugin-y) $(gcc-plugin-ext << 
 63 export GCC_PLUGIN                              << 
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php